commit 6797d560d94c615923f43bcb2f8f0d4255944eed
Author: freddy77 <freddy77>
Date:   Tue Nov 4 15:24:49 2008 +0000

    fix SQLGetData with cursors

diff --git a/ChangeLog b/ChangeLog
index 091ffe0..bda5fab 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Tue Nov 04 16:24:24 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/odbc.c src/odbc/unittests/cursor3.c:
+	- fix SQLGetData with cursors
+
 Tue Nov 04 15:43:25 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/unittests/array.c src/odbc/unittests/array_out.c:
 	* src/odbc/unittests/attributes.c src/odbc/unittests/binary_test.c:
@@ -880,4 +884,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2648 2008/11/04 14:46:17 freddy77 Exp $
+$Id: ChangeLog,v 1.2649 2008/11/04 15:24:49 freddy77 Exp $
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 62a1a75..06b19dc 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.503 2008/10/27 14:23:23 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.504 2008/11/04 15:24:49 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -4648,6 +4648,7 @@ SQLGetData(SQLHSTMT hstmt, SQLUSMALLINT icol, SQLSMALLINT fCType, SQLPOINTER rgb
 {
 	/* TODO cursors fetch row if needed ?? */
 	TDSCOLUMN *colinfo;
+	TDSRESULTINFO *resinfo;
 	TDSSOCKET *tds;
 	TDS_CHAR *src;
 	int srclen;
@@ -4682,15 +4683,18 @@ SQLGetData(SQLHSTMT hstmt, SQLUSMALLINT icol, SQLSMALLINT fCType, SQLPOINTER rgb
 	tds = stmt->dbc->tds_socket;
 	context = stmt->dbc->env->tds_ctx;
 
-	if (!tds->current_results) {
+	resinfo = tds->current_results;
+	if (stmt->cursor && stmt->cursor->res_info)
+		resinfo = stmt->cursor->res_info;
+	if (!resinfo) {
 		odbc_errs_add(&stmt->errs, "HY010", NULL);
 		ODBC_RETURN(stmt, SQL_ERROR);
 	}
-	if (icol <= 0 || icol > tds->current_results->num_cols) {
+	if (icol <= 0 || icol > resinfo->num_cols) {
 		odbc_errs_add(&stmt->errs, "07009", "Column out of range");
 		ODBC_RETURN(stmt, SQL_ERROR);
 	}
-	colinfo = tds->current_results->columns[icol - 1];
+	colinfo = resinfo->columns[icol - 1];
 
 	if (colinfo->column_cur_size < 0) {
 		/* TODO check what should happen if pcbValue was NULL */
diff --git a/src/odbc/unittests/cursor3.c b/src/odbc/unittests/cursor3.c
index b0d621b..f55ae7d 100644
--- a/src/odbc/unittests/cursor3.c
+++ b/src/odbc/unittests/cursor3.c
@@ -1,7 +1,7 @@
 /* Tests 2 active statements */
 #include "common.h"
 
-static char software_version[] = "$Id: cursor3.c,v 1.8 2008/11/04 14:46:17 freddy77 Exp $";
+static char software_version[] = "$Id: cursor3.c,v 1.9 2008/11/04 15:24:49 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int
@@ -48,10 +48,10 @@ main(int argc, char **argv)
 	CHKSetCursorName((SQLCHAR *) "c2", SQL_NTS, "S");
 
 	Statement = stmt1;
-	CHKPrepare((SQLCHAR *) "SELECT * FROM #t1", SQL_NTS, "S");
+	CHKPrepare((SQLCHAR *) "SELECT * FROM #t1 ORDER BY k", SQL_NTS, "S");
 
 	Statement = stmt2;
-	CHKPrepare((SQLCHAR *) "SELECT * FROM #t1", SQL_NTS, "S");
+	CHKPrepare((SQLCHAR *) "SELECT * FROM #t1 ORDER BY k DESC", SQL_NTS, "S");
 
 	Statement = stmt1;
 	CHKExecute("S");
@@ -71,6 +71,24 @@ main(int argc, char **argv)
 	CHKGetData(2, SQL_C_CHAR, (SQLPOINTER) buff, sizeof(buff), &ind, "S");
 	printf(">> Fetch from 2: [%s]\n", buff);
 
+	/*
+	 * this should check a problem with SQLGetData 
+	 * fetch a data on stmt2 than fetch on stmt1 and try to get data on first one
+	 */
+	CHKFetch("S");	/* "ccccccccc" */
+	Statement = stmt1;
+	CHKFetch("S");  /* "bbbbb" */
+	Statement = stmt2;
+	CHKGetData(2, SQL_C_CHAR, (SQLPOINTER) buff, sizeof(buff), &ind, "S");
+	printf(">> Fetch from 2: [%s]\n", buff);
+	if (strcmp(buff, "ccccccccc") != 0)
+		ODBC_REPORT_ERROR("Invalid results from SQLGetData");
+	Statement = stmt1;
+	CHKGetData(2, SQL_C_CHAR, (SQLPOINTER) buff, sizeof(buff), &ind, "S");
+	printf(">> Fetch from 1: [%s]\n", buff);
+	if (strcmp(buff, "bbbbb") != 0)
+		ODBC_REPORT_ERROR("Invalid results from SQLGetData");
+
 	Statement = stmt1;
 	CHKCloseCursor("SI");
 	Statement = stmt2;

